        device zxspectrum1024
toscreen=1
im2=0
HIMEM=0;1
chmwidthchrs=16;22 ;*4 (max=28)
       if toscreen==0
CHMPROG=0
CHSCRLFT=#C8B0-(chmwidthchrs/2); #C090
skyscr=#C010-(chmwidthchrs/2)
CHMINT=1 ; 뢠 뢮
pgchmsel=#9B
pgclchm=#9B
       endif

atm=0 ;0;2=p16c
ystep=1;2 ;1;2 ;must be 2 if atm=0
xstep=4 ;2;4
lace=0 ;0;1 ;must be 0 if ystep=1

chmapwidth=chmwidthchrs*8/xstep

;scalefactor=30535
scalefactor=30535/2
widthfactor=chmapwidth

;᫨  㬭 ⠡,   먣 10%
       if toscreen
pgdsin=#14
pgstepsin=#11
       else
pgdsin=#1C
pgstepsin=#19
       endif

       if toscreen
pgmap=#10
       else
pgmap=#1B
       endif

        if ystep==2
h64=32
        ELSE 
h64=61; 
        ENDIF 

t_u=#4000 ;#800, : (L/32) + (H-'t_u)*8 + #80
       if im2
IMTAB=#4900;#8000
IMER=#4A4A;#8181
IMSTACK=0x5c00;IMER
       endif
tempsteps=0x5b00;#4B00 ;,64

timer=23672

       if toscreen==0
        MACRO lowon
       ;IN A,(#FB)
        LD A,(cureff7)
        OR 8
        LD (cureff7),A
        LD BC,#EFF7
        OUT (C),A
        ENDM 

        MACRO lowoff
       ;IN A,(#7B)
        LD A,(cureff7)
        AND #F7
        LD (cureff7),A
        LD BC,#EFF7
        OUT (C),A
        ENDM 

        MACRO c16on
        LD A,(cureff7)
        OR 1
        LD (cureff7),A
        LD BC,#EFF7
        OUT (C),A
        ENDM 

        MACRO c16off
        LD A,(cureff7)
        AND #FE
        LD (cureff7),A
        LD BC,#EFF7
        OUT (C),A
        ENDM 
       endif

       if HIMEM
        MACRO setpg pg
        LD A,pg
        LD (curpg),A
        LD BC,#7FFD
        OUT (C),A
        ENDM 
       endif


        ORG #6000;#8200
progbegin
GO
      ;LD SP,#6000
       if toscreen
        halt
        xor a
        out (0xfe),a       
        ld hl,0x5800
        ld de,0x5801
        ld bc,767
        ld (hl),l
        ldir
       else
        ld de,0x1013
        ld hl,0xc000
copypg0
        out (c),d
        ld a,(hl)
        out (c),e
        ld (hl),a
        inc l
        jr nz,copypg0
        inc h
        jr nz,copypg0
      
        setpg #16
        CALL CLPG
        setpg #17
        CALL CLPG
       endif

       if toscreen
        ld hl,tempsteps+128
        ld de,0x5000
        ld b,h64
drawprepty0
        ld (hl),e
        inc l
        ld (hl),d
        inc l
        call DDE2
        djnz drawprepty0
       endif

       if im2
        DI 
        LD HL,CHMIMER
        CALL SETINT
        EI 
       endif
       if toscreen==0
        lowon
        LD A,chmwidthchrs
        CALL MKCHMPROG
       endif

       IF atm
;砩   ᥫ   ⥪ ⠩
        LD HL,tiles;#8000
        LD DE,0
        ld b,64
RETILE0
        LD A,(DE)
        XOR H
        XOR L
        RRA 
        CALL C,SWAPINKPAP
        INC HL
        INC DE
        inc l
        jr nz,RETILE0
        inc h
        djnz RETILE0
       ELSE ;~atm
; 梥⮢   砭 (F7..FF)
        LD HL,tiles;#8000
        ld b,64
RETILE0
        LD A,(HL)
       if toscreen
        ;and 0xf0
        ;cp 0x80
        ;jr nz,$+3
        ;xor a
        ;cp 0xc0
        ;jr nz,$+4
        ;ld a,0x40
        cp 0b11110110
        jr z,setyellow
        cp 0b10110110
        jr z,setyellow
        cp 0b01110110
        jr z,setyellow
        cp 0b11110010
        jr z,setyellow
        cp 0b11010110
        jr z,setyellow
        cp 0b10010110
        jr z,setyellow
        cp 0b01110010
        jr z,setyellow

        cp 0b11110000
        jr z,setyellow
        cp 0b11000110
        jr z,setyellow
        cp 0b10110000
        jr z,setyellow
        cp 0b01000110
        jr z,setyellow
        cp 0b01010100
        jr z,setyellow
        cp 0b10100010
        jr z,setyellow
        ;sub 0b10111000
        ;jr z,nosetyellow
        ;sub 0b01000111
        ;jr z,nosetyellow
        ;ld a,(hl)
        jr nosetyellow
setyellow
        ld a,0x20
nosetyellow
        and 0x30
         if 0
         and 7
         bit 6,(hl)
         jr z,$+4
         or 8 ;ink
         ld c,a
         
         ld de,trecolor
         add a,e
         ld e,a
         jr nc,$+3
         inc d
         ld a,(de)
         endif
        ld c,a
        rrca
        rrca
        or c
        ld c,a
        rrca
        rrca
        rrca
        rrca
        or c
       else
        AND 7
        BIT 6,(HL)
        jr z,$+3
        ADD A,A
        LD C,A ;0..14
        LD A,(HL)
        RRA 
        RRA 
        RRA 
        AND 7
        BIT 7,(HL)
        jr z,$+3
        ADD A,A ;A=0..14
        ADD A,C ;A=0..28
        RRA ;A=0..14
        SUB 2
        jr nc,$+3
        XOR A
        ADD A,#F7
        jr nc,$+3
        SBC A,A
       IF xstep==4
        ADD A,A
        SUB 0xff&(#F7*2-#DB)
       ENDIF 
       endif
        LD (HL),A
        inc l
        jr nz,RETILE0
        inc h
        djnz RETILE0
       ENDIF 

        CALL MKt_u

        LD HL,f_v
MKf_v0  LD A,L
        RLCA 
        RLCA 
        RLCA 
        AND 7
        ADD A,t_u/256
        LD (HL),A
        INC L
        jr nz,MKf_v0

       if HIMEM
        setpg pgstepsin
        LD HL,#C000
PREPstep
        PUSH HL
       LD C,L
       LD B,tsin/256
        LD L,H ;#C0..#FF
        LD H,tstep_z/256
;step(z)=k2/z ; ⠡
        LD E,(HL)
        LD D,0
;du=stepx(z,a)= step(z)*sin(a) ;+-.7 = .8 * +-.7
       LD A,(BC)
        CALL MULSIGN
       ADD HL,HL
        LD A,H
        POP HL
        LD (HL),A
        INC HL
        BIT 6,H
        jr nz,PREPstep

        setpg pgdsin
        LD H,#C0
PREPdsin
        LD L,0
PREPdsin0
        PUSH HL
       LD A,64
       SUB L
       LD C,A
       LD B,tsin/256
        LD L,H ;#C0..#FF
        LD H,td_z/256
;d(z)=k1/z ; ⠡
        LD E,(HL)
        INC H
        LD D,(HL)
;d(z)*cos(a)   ;+-7.8 = 8.8 * +-.7
       LD A,(BC) ;cos
        CALL MULSIGN
        LD L,H
        ld H,A
       ADD HL,HL
        ex de,hl
        POP HL
        LD (HL),E
        SET 7,L
        LD (HL),D
        RES 7,L
        INC L
        JP P,PREPdsin0
        INC H
        BIT 6,H
        jr nz,PREPdsin
       endif

        LD HL,#C000;PROG

       IF atm
       IF lace
        setpg pgclchm
        LD (CHMSEL1JP),HL
        LD DE,CHSCRLFT
        LD A,chmwidthchrs
        PUSH AF,DE
        CALL MKCHMSEL
        POP DE
        CALL DDE
        POP AF
        LD (CHMSEL2JP),HL
        CALL MKCHMSEL
       ENDIF 
       ENDIF 

       IF atm
        setpg pgclchm
        LD (CLCHMJP),HL
        LD A,chmwidthchrs
        CALL MKCLCHM
       ENDIF 

       IF atm
        LD A,%11101101
        LD (boxcol1),A
        LD (boxcol2),A
        LD HL,skyscr;#C002
        LD C,96
        CALL BOX16 ;
        LD A,%00110100
        LD (boxcol1),A
        LD A,%00100110
        LD (boxcol2),A
        LD C,8
        CALL BOX16 ;
       ENDIF 

      ; DI ;?
      ; CALL INIT_3D
      ; EI ;?

       IF atm
        setpg #1F
        c16on
       ELSE 
       if toscreen
        LD HL,#5800
        LD DE,#5801
        ld (hl),0
        ld bc,256
        ldir
        LD (HL),7
        LD BC,767-256
        LDIR 
       else
        setpg #1F
        LD HL,#D800
        LD DE,#D801
        LD (HL),7
        LD BC,767
        LDIR 
; ⠡  砭-> 
;砭=#F7..#FF
; =#DB..#F5 ()
        LD HL,TCHTOAD
        LD D,#F7
MKTCH0  LD E,#F7
MKTCH1  LD A,(HL)
        LD (DE),A
        INC HL
        INC E
        jr nz,MKTCH1
        INC D
        jr nz,MKTCH0
; ⠡  4 砭->䨪 砭
;HSB=  砭, LSB=ࠢ
        LD D,#DB
MKTGCH0 LD E,#DB
MKTGCH1 LD HL,TCHGFX
        LD A,E
        SUB #DB
        ADD A,L
        LD L,A
        jr nc,$+3
        INC H
        LD C,(HL)
        INC HL
        LD B,(HL)
        LD HL,TCHGFX
        LD A,D
        SUB #DB
        ADD A,L
        LD L,A
        jr nc,$+3
        INC H
        LD A,(HL)
        XOR C
        AND #F0
        XOR C
        LD (DE),A
        DEC E
        INC HL
        LD A,(HL)
        XOR B
        AND #F0
        XOR B
        LD (DE),A
        INC E
        INC E
        INC E
        LD A,E
        CP #F7
        jr nz,MKTGCH1
        INC D
        INC D
        LD A,D
        CP #F7
        jr nz,MKTGCH0
       endif
       ENDIF 
      ;CALL CHMSEL
      
       ld a,(timer)
       ld (oldtimer),a
       jp EFLOOP
       
       if !HIMEM
       align 256
tiles
        INCBIN "m7zxtile.bin"
       endif
      
EFLOOP
      ; CALL CLCHM

        CALL DRAW

waittimer
        ld a,(timer)
oldtimer=$+1
        ld c,0
        ld (oldtimer),a
        sub c
        jr z,waittimer
        ld b,a
calllogic0
        push bc
        call logic
        pop bc
        djnz calllogic0

       if toscreen==0
       IF atm
       IF lace
        setpg pgchmsel
        CALL CHMSEL
       ENDIF 
       ENDIF 
        CALL CHMOUT
       ;CALL CHMSEL
       ;CALL CHMOUT
       endif
        LD A,#BF
        IN A,(#FE)
        RRA 
        JR C,EFLOOP
       if toscreen==0
        c16off
        lowoff
       endif
        IM 1
        RET 

;trecolor
;        db 0,0,1,1,2,2,1,2,0,0,1,1,2,2,3,3

       IF atm==0
TCHTOAD
         ;R=0   1   1   2   2   3   3   4   4
        db #DB,#DD,#DD,#DF,#DF,#E1,#E1,#EF,#EF ;L=0
        db #DB,#DD,#DD,#DF,#DF,#E1,#E1,#EF,#EF ;L=0
        db #ED,#DF,#DF,#E1,#E1,#EF,#EF,#E5,#E5 ;L=1
        db #ED,#DF,#DF,#E1,#E1,#EF,#EF,#E5,#E5 ;L=1
        db #DF,#F1,#F1,#E3,#E3,#E5,#E5,#E7,#E7 ;L=2
        db #DF,#F1,#F1,#E3,#E3,#E5,#E5,#E7,#E7 ;L=2
        db #F1,#F3,#F3,#F5,#F5,#E7,#E7,#E9,#E9 ;L=3
        db #F1,#F3,#F3,#F5,#F5,#E7,#E7,#E9,#E9 ;L=3
        db #F3,#F5,#F5,#E7,#E7,#E7,#E7,#EB,#EB ;L=4
TCHGFX
          ;gfx ;adr;bri
        db #00,#00 ;DB:00
        db #22,#00 ;DD:01
        db #AA,#00 ;DF:11
        db #AA,#11 ;E1:12
        db #AA,#55 ;E3:22
        db #BB,#55 ;E5:23
        db #FF,#55 ;E7:33
        db #FF,#77 ;E9:34
        db #FF,#FF ;EB:44
        db #88,#00 ;ED:10
        db #BB,#11 ;EF:13
        db #AA,#44 ;F1:21
        db #EE,#44 ;F3:31
        db #EE,#55 ;F5:32
       ENDIF 

       IF atm
BOX16
;HL=screen
;C=hgt
BOX160
        PUSH BC,HL
        setpg #1E
        CALL BOX16LINE
        SET 5,H
        CALL BOX16LINE
        setpg #1F
        CALL BOX16LINE
        RES 5,H
        CALL BOX16LINE
        POP HL,BC
        ex de,hl 
        CALL DDE
        ex de,hl 
        DEC C
        jr nz,BOX160
        RET 
BOX16LINE
        PUSH HL
        LD D,H
        ld E,L
        INC DE
        LD BC,chmwidthchrs-1
boxcol1=$+1
        LD (HL),0
        BIT 0,H
        jr NZ,$+4
boxcol2=$+1
        LD (HL),0
        LDIR 
        POP HL
        RET 

SWAPINKPAP
        LD A,(HL) ;YyGRBgrb
        RLA 
        RLA 
        RLA 
        AND #38
        LD C,A    ;00grb000
        LD A,(HL)
        RRA 
        RRA 
        RRA 
        AND 7
        OR C
                  ;00grbGRB
        BIT 7,(HL)
        jr z,$+4
        OR 64
        BIT 6,(HL)
        jr z,$+4
        OR 128
        LD (HL),A ;yYgrbGRB
        RET 
       ENDIF 

MULSIGN
       if 0
        bit 7,a
        jr z,MUL1
        neg
        call MUL1
        LD C,A
        XOR A
        SUB L
        LD L,A
        LD A,0
        SBC A,H
        LD H,A
        SBC A,A
        SUB C
        ret
MUL1
       push bc
;AHL = DE * A
        ld b,a
        ld hl,0
        xor a
        ld c,a
       dup 8
        add hl,hl
        rla
        rl b
        jr nc,$+4
        ADD HL,DE
        ADC A,C ;C=0
       edup
       pop bc
        ret
       endif

;AHL = DE * A
;+-7.16 = 8.8 * +-.7
        LD HL,0
        LD C,L ;C=0
        ADD A,A
        jr nc,MULnROLL
        NEG 
        ADD A,A
        CALL MULnROLL+1 ;ய RLA
        LD C,A
        XOR A
        SUB L
        LD L,A
        LD A,0
        SBC A,H
        LD H,A
        SBC A,A
        SUB C
        RET 
MUL
;AHL = DE * A
;24. = 16. * 8.
;16.8 = 8.8 * 8.
;8.16 = 8.8 * .8
        LD HL,0
        LD C,L
        ADD A,A
        jr nc,$+4
        ADD HL,DE
        ADC A,C ;C=0
        ADD HL,HL
MULnROLL
       DUP 6
        RLA 
        jr nc,$+4
         ADD HL,DE
         ADC A,C ;C=0
        ADD HL,HL
       EDUP 
        RLA 
        RET NC
        ADD HL,DE
        ADC A,C
        RET 

DRAW
        LD A,(angle)
        LD (curangle),A
        LD A,(jump)
        SRL A
        SRL A
        NEG 
        ADD A,#80-13
        LD (curjump),A
        LD HL,(x0)
        LD (curx0),HL
        LD HL,(y0)
        LD (cury0),HL
curangle=$+1
        LD HL,tsin+34+64
        LD A,(HL) ;sin
        RLA 
        LD A,131 ;ADD A,E
        LD C,44 ;INC L
        jr nc,$+6
        LD A,147 ;SUB E
        LD C,45 ;DEC L
        CALL patchJU
        LD A,C
        CALL patchIU

        LD A,#40
        SUB L
        LD L,A
        LD A,(HL) ;cos
        NEG 
        RLA 
        LD A,130 ;ADD A,D
        LD C,36 ;INC H
        jr nc,$+6
        LD A,146 ;SUB D
        LD C,37 ;DEC H
        CALL patchJV
        LD A,C
        CALL patchIV
        ;६ 稭 = 13*chmwidthchrs*2*4 = 2912 (1%)
        ;  ⮫쪮  

;⠥ stepx, stepy
;du=stepx(z,a)= step(z)*sin(a) ;+-.7 = .8 * +-.7
;f(z,a) L,H
;dv=stepy(z,a)=-step(z)*cos(a) ;+-.7 = .8 * +-.7
;f(z,a-64) L,H
       if HIMEM
        setpg pgstepsin
       endif
curjump=$+1
        LD DE,0
        SLA E
        RL D
        LD IX,#C000
       IF ystep==2
       IF lace
begLA=$+1
       LD A,#55
       RRCA 
       LD (begLA),A
        jr c,$+4 ;2 ࠧ ய
        ADD IX,DE
       ENDIF 
        SLA E
        RL D
        DUP 4
        ADD IX,DE
        EDUP 
       ELSE 
        DUP 8
        ADD IX,DE
        EDUP 
       ENDIF 
        EXX 
        LD A,(curangle)
       if HIMEM
        LD C,A
        SUB 64
        LD B,A
       else
        ld (tempsteps_a),a
        SUB 64
        ld (tempsteps_am64),a
       endif
        LD HL,tempsteps
        EXX 
        LD B,h64
DRAWPREPh64
        EXX 
       if HIMEM
        LD D,HX
        LD E,C
        LD A,(DE)
        LD (HL),A
        INC L
        LD E,B
        LD A,(DE)        
        LD (HL),A
        INC L
       else
       push hl
        ld a,hx
        LD L,a ;#C0..#FF
        LD H,tstep_z/256
;step(z)=k2/z ; ⠡
        LD E,(HL)
        LD D,0
;du=stepx(z,a)= step(z)*sin(a) ;+-.7 = .8 * +-.7
tempsteps_a=$+1
       LD A,(tsin)
        CALL MULSIGN
       ADD HL,HL
        LD b,H
;du=stepx(z,a)= step(z)*sin(a) ;+-.7 = .8 * +-.7
tempsteps_am64=$+1
       LD A,(tsin)
        CALL MULSIGN
       ADD HL,HL
        LD A,H
       pop hl
        ld (hl),b
        inc l
        LD (HL),A
        inc l
       endif
        EXX 
        ADD IX,DE
        DJNZ DRAWPREPh64       
        XOR A
        SUB E
        LD C,A
        SBC A,A
        SUB D
        LD B,A
        EXX 

       if HIMEM
       ;C=curangle
        LD L,C
        setpg pgdsin
; ᪠ cos:
;00..3F
;40..7F
;80..BF -> 7F..40
;C0..FF -> 3F..00
        LD A,L
        OR A
        JP P,$+4
        CPL 
        LD C,A ;C=0..127  cos
; ᪠ sin:
;00..3F -> 3F..00
;40..7F -> FF..C0 -> 00..3F
;80..BF -> BF..80 -> 40..7F
;C0..FF -> 7F..40
        LD A,64
        SUB L
        JP P,$+4
        CPL 
               ;A=0..127  sin
       else
        ld a,(curangle)
        ld (sina),a
        neg
        add a,64
        ld (cosa),a
       endif
        LD B,h64
DRAWPREPd
        EXX 
        ADD IX,BC
        EXX 
       if HIMEM
        LD E,HX
        LD H,E
        LD L,A
        LD E,(HL)
        SET 7,L
        LD D,(HL) ;sin*d
       PUSH DE
        LD L,C
        LD E,(HL)
        SET 7,L
        LD D,(HL) ;cos*d
       PUSH DE
       else
        LD a,HX
        LD l,a ;#C0..#FF
        LD H,td_z/256
;d(z)=k1/z ; ⠡
        LD E,(HL)
        INC H
        LD D,(HL)
;d(z)*sin(a)   ;+-7.8 = 8.8 * +-.7
sina=$+1
       LD A,(tsin) ;sin
        CALL MULSIGN
        LD L,H
        ld H,A
       ADD HL,HL
       PUSH hl
;d(z)*cos(a)   ;+-7.8 = 8.8 * +-.7
cosa=$+1
       ld a,(tsin) ;cos
        CALL MULSIGN
        LD L,H
        ld H,A
       ADD HL,HL
       PUSH hl
       endif
        DJNZ DRAWPREPd

       if HIMEM
        setpg pgmap
       endif
        LD ix,tempsteps
DRAW0
        LD L,(ix)
        LD E,L ;du
;du=stepx(z,a)= step(z)*sin(a) ;+-.7 = .8 * +-.7
;leftx(z,a)=cx(z,a)-width*stepx(z,a) ;㬭  ⠡
        LD H,tmulwidth/256
        LD C,(HL)
        INC H
        LD B,(HL) ;bc=-du*width
       POP HL ;cos*d
        ADD HL,BC
curx0=$+1
        LD BC,0
        ADD HL,BC
        LD A,H
        EXX 
        LD L,A; U
        EXX 
        LD A,L
       inc lx
        LD L,(ix);(ix+1)
        LD D,L ;dv
;dv=stepy(z,a)=-step(z)*cos(a) ;+-.7 = .8 * +-.7
;lefty(z,a)=cy(z,a)-width*stepy(z,a) ;㬭  ⠡
        LD H,tmulwidth/256
        LD C,(HL)
        INC H
        LD B,(HL) ;bc=-dv*width
       POP HL ;sin*d
        ADD HL,BC
cury0=$+1
        LD BC,0
        ADD HL,BC
        LD C,A ;u
        LD A,H
                    ;L=v
        EXX 
        LD H,A ;V
        SET 7,H
        BIT 6,H
        SET 6,H
        jr z,$+6
        LD A,L
        XOR 128
        LD L,A

       if toscreen
        ld e,(ix+127)
        inc lx
        ld d,(ix+127)
       else
        LD A,lx
        inc lx
        SRL A
        ADD A,CHMPROG/256
        LD D,A
       endif
        EXX 
        LD H,f_v/256   ;H='f(v)
       SLA D
       jr nc,$+5
       XOR A
       SUB D
       LD D,A
       SLA E
       jr nc,$+5
       XOR A
       SUB E
       LD E,A
       CALL M7LOOP_PP
        ;INC lx
       ;INC lx
        LD A,lx
        CP h64*2
        JP C,DRAW0
        RET 

       if toscreen==0
MKCLCHM
;A=chmwidthchrs (2,4,...,28)
        RRCA 
        LD LX,A
        LD BC,CHMPROG
        CALL MKCLCHMPP
        LD BC,CHMPROG+64
        CALL MKCLCHMPP
        LD BC,CHMPROG+128
        CALL MKCLCHMPP
        LD BC,CHMPROG+192
        CALL MKCLCHMPP
        LD (HL),201
        INC HL
        RET 
MKCLCHMPP
        LD HX,h64
MKCLCHMPP0
        PUSH BC
        LD A,LX
MKCLCHMPP1
        LD (HL),34 ;LD (..),HL
        INC HL
        INC BC,BC,BC,BC
        LD (HL),C
        INC HL
        LD (HL),B
        INC HL
        DEC A
        jr nz,MKCLCHMPP1
        POP BC
        INC B
        DEC HX
        jr nz,MKCLCHMPP0
        RET 

CLCHM
        setpg pgclchm
        LD HL,0
CLCHMJP=$+1
        JP 0

       IF atm
       IF lace
CHMSEL
; 맮 - CHMSEL1
;ன 맮 - CHMSEL2
;...
CHMSELA=$+1
        LD A,#55
        RRCA 
        LD (CHMSELA),A
        jr nc,CHMSEL2
CHMSEL1
        setpg pgchmsel
CHMSEL1JP=$+1
        JP 0
CHMSEL2
        setpg pgchmsel
CHMSEL2JP=$+1
        JP 0

MKCHMSEL
;A=chmwidthchrs (2,4,...,28)
        LD LX,A
;HL=PROG+
;DE=screen upper left corner
       IF CHMINT
;patch UL corner addr (LD (..),HL)
        PUSH DE
        LD BC,CHMPROG+1
        CALL MKCHMSELPPadd ; ४樥 BC
        LD BC,CHMPROG+65
        CALL MKCHMSELPPadd
        SET 5,D
        LD BC,CHMPROG+129
        CALL MKCHMSELPPadd
        LD BC,CHMPROG+193
        CALL MKCHMSELPPadd
        POP DE
       ENDIF 
;patch UR corner addr (LD SP,..)
        LD A,E
        ADD A,LX
        LD E,A
        jr nc,$+3
        INC D ;for ATM
        LD BC,CHMPROG+1
        CALL MKCHMSELPP
        LD BC,CHMPROG+65
        CALL MKCHMSELPP
        SET 5,D
        LD BC,CHMPROG+129
        CALL MKCHMSELPP
        LD BC,CHMPROG+193
        CALL MKCHMSELPP
        LD (HL),201
        INC HL
        RET 
       IF CHMINT
MKCHMSELPPadd
        LD A,C
        ADD A,LX
        ADD A,LX
        ADD A,2
        LD C,A
       ENDIF 
MKCHMSELPP
;HL=PROG+
;DE=screen addr
;BC=patch address
        PUSH DE
        BIT 6,C
        JZ MKCHMSELPPNXOR
       ; LD A,D
       ; XOR 1
       ; LD D,A ; 嬠⭮ ᪨ 뢮
MKCHMSELPPNXOR
        LD HX,h64
MKCHMSELPP0
        LD (HL),33
        INC HL
        LD (HL),E
        INC HL
        LD (HL),D
        INC HL
        LD (HL),34 ;LD (..),HL
        INC HL
        LD (HL),C
        INC HL
        LD (HL),B
        INC HL
        INC B
        CALL DDE2
        DEC HX
        JNZ MKCHMSELPP0
        POP DE
        RET 
       ENDIF ;lace
       ENDIF ;atm
       endif

curpg
        DB #10
cureff7
        DB 0

       if im2
SETINT
        LD A,195
        LD (IMER),A
        LD (IMER+1),HL
        LD HL,IMTAB
        LD DE,IMTAB+1
        LD BC,256
        LD (HL),0xff&IMER
        LD A,H
        LDIR 
        LD I,A
        IM 2
        RET 

CHMIMER
; HL  ⥪   맮
        EX (SP),HL
        LD (CHMIMERJP),HL
; 塞 SP
        LD (CHMIMERSP),SP
        LD SP,IMSTACK
        PUSH AF,BC,DE
        PUSH IX,IY
        EXX 
        ex af,af' ;'
        PUSH AF,BC,DE,HL
        
        ld hl,timer
        inc (hl)
        ;call logic
     ; CALL INTSRV

        POP HL,DE,BC,AF
        EXX 
        ex af,af' ;' 
        POP IY,IX
        POP DE,BC,AF
CHMIMERSP=$+1
        LD SP,0
        POP HL
        EI 
CHMIMERJP=$+1
        JP 0
       endif
        
logic
        CALL INKEY
angspeed=$+1
        LD E,0
        LD A,C
        CPL 
        AND %00110000 ;LR
        jr nz,$+4
        LD E,0
        BIT 5,C ;L
        jr nz,angnR
         LD A,E
         DEC A
         BIT 7,A
        jr z,$+3 ;>0
        LD E,20
        LD A,E
        CP 77
        jr z,angnR
        INC E
angnR
        BIT 4,C ;R
        jr nz,angnL
        BIT 7,E
        jr nz,$+4 ;<0
        LD E,-20
        LD A,E
        CP -77
        jr z,angnL
        DEC E
angnL
        LD A,E
        LD (angspeed),A
jumpspeed=$+1
jump=$+2
        LD HL,0
        LD A,H
        OR A
        JP NZ,angnGND
        LD L,-1
angnGND
        INC L
        BIT 0,C
        jr nz,angnJ
        LD A,H ;jump
        OR A
        jr nz,angnJ
        LD L,-20
angnJ
        LD A,H
        SUB L
        LD H,A
        LD (jumpspeed),HL

bigangle=$+1
        LD HL,#5500
        LD A,E
        RLA 
        SBC A,A
        LD D,A
        DUP 10
        ADD HL,DE
        EDUP 
        LD (bigangle),HL
        LD A,H
        LD (angle),A
angle=$+1
        LD HL,tsin+34+64
        LD A,(HL) ;sin
speed=$+1
        LD DE,#0083
        CALL MULSIGN
        LD A,H
        LD L,A
        RLA 
        SBC A,A
        LD H,A
y0=$+1
        LD DE,0
        ADD HL,DE
        LD (y0),HL

        LD HL,(angle)
        LD A,#40
        SUB L
        LD L,A
        LD A,(HL) ;cos
        LD DE,(speed)
        CALL MULSIGN
        LD A,H
        LD L,A
        RLA 
        SBC A,A
        LD H,A
x0=$+1
        LD DE,0
        ADD HL,DE
        LD (x0),HL
        ret

INKEY
;C=11LRDUBF (B=break)
        LD A,#FE
        IN A,(254)
        RRA 
        LD A,#EF
        IN A,(254)
        JR C,UANOCAP
        LD C,#FF
        RRA     ;CS+"0" = "0"
        jr c,$+3
        DEC C
        RRA 
        RRA     ;CS+"8"
        jr c,$+4
        RES 4,C
        RRA     ;CS+"7"
        jr c,$+4
        RES 2,C
        RRA     ;CS+"6"
        jr c,$+4
        RES 3,C
        LD A,#F7
        IN A,(254)
        BIT 4,A ;CS+"5"
        jr nz,$+4
        RES 5,C
        RLA     ;CS+"1"
        jr c,INKEYF
        RES 1,C
        JR INKEYF
UANOCAP
        RRCA 
        RLA 
        RLA 
        OR #C2
        LD C,A
        LD A,#DF
        IN A,(254)
        RRA     ;"P"
        JR C,$+4
        RES 4,C
        RRA     ;"O"
        JR C,$+4
        RES 5,C
        LD A,#FB
        IN A,(254)
        RRA     ;"Q"
        JR C,$+4
        RES 2,C
        RRA 
        RRA     ;"E"
        JR C,$+4
        RES 1,C
        LD A,#FD
        IN A,(254)
        RRA     ;"A"
        jr c,$+4
        RES 3,C
INKEYF  LD A,#7F
        IN A,(254)
        CPL 
        AND 31
        RET Z
        RES 0,C
        RET 

       if toscreen==0
CHMOUT
       IF atm
        LD (CHMOUTSP),SP
        setpg #1E
        LD IX,CHMCALLQ0
        JP CHMPROG
CHMCALLQ0
        LD IX,CHMCALLQ2
        JP CHMPROG+128
CHMCALLQ2
        setpg #1F
        LD IX,CHMCALLQ1
       IF xstep==4
        JP CHMPROG
       ELSE 
        JP CHMPROG+64
       ENDIF 
CHMCALLQ1
        LD IX,CHMCALLQ3
       IF xstep==4
        JP CHMPROG+128
       ELSE 
        JP CHMPROG+192
       ENDIF 
CHMCALLQ3
CHMOUTSP=$+1
        LD SP,0
        RET 
       ELSE ;~atm
        setpg #1F
        JP CHMPROG
       ENDIF 
       endif

CLPG
        LD HL,#C000
        LD DE,#C001
        LD BC,#3FFF
        LD (HL),L
        LDIR 
        RET 

       if toscreen==0
       IF atm
MKCHMPROG
;A=chmwidthchrs (2,4,...,28)
        LD (mkchmlaywidth),A
        RRCA 
        LD (mkchmlaywidthdiv2),A
;4 ᫮ 
;LD SP,
;LD DE,:PUSH DE *14
;JP
        LD HL,CHMPROG
        LD DE,CHSCRLFT
        CALL MKCHMLAYER
        LD HL,CHMPROG+64
        CALL MKCHMLAYER
        SET 5,D
        LD HL,CHMPROG+128
        CALL MKCHMLAYER
        LD HL,CHMPROG+192
MKCHMLAYER
;HL=code addr
;DE=screen addr ( ஭)
        PUSH DE
        LD C,h64
;C=᫮ ப
MKCHMlay
       PUSH HL
; ப ᫮
        LD (HL),49
        INC HL
        LD A,E
mkchmlaywidth=$+1
        ADD A,chmwidthchrs
        LD (HL),A
        INC HL
        LD (HL),D
        jr nc,$+3
        INC (HL)
mkchmlaywidthdiv2=$+1
        LD B,chmwidthchrs/2
MKCHMln
        INC HL
        LD (HL),33
        INC HL
       XOR A
        LD (HL),A
        INC HL
        LD (HL),A
        INC HL
        LD (HL),229
        DJNZ MKCHMln
       IF CHMINT
        LD (HL),34 ;LD (..),HL
        INC HL
        LD (HL),E
        INC HL
        LD (HL),D
       ENDIF 
        INC HL
       ;BC= ?
        LD (HL),195
        PUSH HL
        POP IX
       POP HL
        INC H
        LD (IX+1),L
        LD (IX+2),H
        CALL DDE2
        DEC C
        jr nz,MKCHMlay
        LD (IX),#DD
        LD (IX+1),233 ;JP (IX)
        POP DE
        RET 
       ELSE ;~atm
MKCHMPROG
;A=chmwidthchrs (2,4,...,22)
        LD (mkchmlaywidth),A
        DEC A
        LD (mkchmlaywidthm1),A
        LD HL,CHMPROG ;HL=code addr
        LD DE,CHSCRLFT ;DE=screen addr ( ஭)
        LD C,h64 ;C=᫮ ப
MKCHMlay
       PUSH HL
; ப
;LD DE,eol:LD BC,eol+257
;DUP 11
;LD HL,(...)
;LD A,(...)
;LD H,A
;LDD
;LD A,(HL)
;LD (BC),A
;EDUP
;JP
        LD (HL),17
        INC HL
        LD A,E
mkchmlaywidthm1=$+1
        ADD A,chmwidthchrs-1
        LD B,D
        jr nc,$+3
        INC B
        LD (HL),A
        INC HL
        LD (HL),B
        INC HL
        INC A
        INC B
        LD (HL),1
        INC HL
        LD (HL),A
        INC HL
        LD (HL),B
        INC HL
mkchmlaywidth=$+1
        LD B,chmwidthchrs
MKCHMln
       IF xstep==4
        LD (HL),#21 ;LD HL,
        INC HL
       LD A,#DB
        LD (HL),A
        INC HL
        LD (HL),A
        INC HL
       ELSE 
        LD (HL),#2A ;LD HL,()
        INC HL
       LD A,#F7
        LD (HL),A
        INC HL
        LD (HL),A
        INC HL
        LD (HL),#3A ;LD A,()
        INC HL
        LD (HL),A
        INC HL
        LD (HL),A
        INC HL
        LD (HL),#67 ;LD H,A
        INC HL
       ENDIF 
        LD (HL),#ED
        INC HL
        LD (HL),#A8 ;LDD
        INC HL
        LD (HL),#7E ;LD A,(HL)
        INC HL
        LD (HL),#02 ;LD (BC),A
        INC HL
        DJNZ MKCHMln
       ;BC= ?
        LD (HL),195
        PUSH HL
        POP IX
       POP HL
        INC H
        LD (IX+1),L
        LD (IX+2),H
        CALL DDE2
        DEC C
        jr nz,MKCHMlay
        LD (IX),#C9 ;RET
        RET 
       ENDIF 
       endif

MKt_u
;#800, : (L/32) + (H-'t_u)*8 + (tiles/256);#80
        LD HL,t_u
        LD B,8
MKt_u0
MKt_u1
        LD A,L
        RLCA 
        RLCA 
        RLCA 
        AND 7
        LD C,A ;L/32
        LD A,H
        SUB t_u/256
        ADD A,A
        ADD A,A
        ADD A,A
        ADD A,C ;L/32
        ADD A,tiles/256;#80
        LD (HL),A
        INC L
        jr nz,MKt_u1
        INC H
        DJNZ MKt_u0
        RET 

DDE2
       IF ystep==2
        CALL DDE
       ENDIF 
DDE
        INC D
        LD A,D
        AND 7
        RET NZ
        LD A,E
        ADD A,32
        LD E,A
        RET C
        LD A,D
        ADD A,-8
        LD D,A
        RET 

      ; INCLUDE "3DROTPP*",#C5

        align 256;DS .(-$)
tsin
        INCBIN "sin.bin"

td_z
;65536/(.$) = 16384/(.$)*4
;low
        DUP 256
       if $&63
        DB 0xff&(scalefactor/($&63)*2)
       else
        db 0
       endif
        EDUP 
;high
        DUP 256
       if $&63
        DB (scalefactor/($&63)*2)/256
       else
        db 0
       endif
        EDUP 
tstep_z
;65536/(2*chmwidthchrs)/(.$) = 16384/(2*chmwidthchrs)*4/(.$)
tstep_zconst=450
       IF xstep==4
tstep_zconst=tstep_zconst*2
       ENDIF 
;low only
        DUP 256
       if $&63
        DB 0xff&(tstep_zconst/($&63))
       else
        db 0
       endif
        EDUP 
tmulwidth
;-(2*chmwidthchrs*(.$))
;low
        DUP 128
        DB 0xff&(-(widthfactor*($&0xff)))
        EDUP 
        DUP 128
        DB 0xff&(widthfactor*(256-($&0xff)))
        EDUP 
;high
        DUP 128
        DB ((-(widthfactor*($&0xff)))&0xff00)/256
        EDUP 
        DUP 128
        DB (widthfactor*(256-($&0xff)))/256
        EDUP 

       if toscreen==0
TCHX
;.   CHMAP
;L=f(X), chmwidthchrs*4 祭
       IF atm
chcurl=((chmwidthchrs/2)-1)*4+4
        DUP chmwidthchrs/2
        DB chcurl
        DB chcurl+64
        DB chcurl+128
        DB chcurl+192
        DB chcurl+1
        DB chcurl+65
        DB chcurl+129
_=chcurl+193
        DB _;chcurl+193
chcurl=chcurl-4
        EDUP 
       IF chmwidthchrs==28
        DS (-$)&0xff,_;{$-1} ; ⮩ 
       ELSE 
        DS (-$)&0xff,#FF ; 
       ENDIF 
       ELSE ;~atm
       IF xstep==4
chcurl=(chmwidthchrs-1)*7+7
        DUP chmwidthchrs
        DB chcurl+1
        DB chcurl+1
        DB chcurl
        DB chcurl
chcurl=chcurl-7
        EDUP 
       ELSE 
chcurl=(chmwidthchrs-1)*11+7
        DUP chmwidthchrs
        DB chcurl+4
        DB chcurl+3
        DB chcurl+1
        DB chcurl
chcurl=chcurl-11
        EDUP 
       ENDIF 
        DS (-$)&0xff,#FF ; 
       ENDIF 
;  INC L:JNZ
        ORG $-chmapwidth
       IF xstep==4
        DUP chmapwidth
        DB 0xff&{($+chmapwidth-256-TCHX)*2+TCHX}
        EDUP 
       ELSE 
        DUP chmapwidth
        DB 0xff&{$+chmapwidth-256}
        EDUP 
       ENDIF 
       endif

; ᬥ ᫮ JR  M7ZX
patchJV
_patchJV=$
        DS 3*(chmapwidth-1)
        RET 
patchIV
_patchIV=$
        DS 3*(chmapwidth-1)
        RET 
patchJU
_patchJU=$
        DS 3*(chmapwidth-1)
        RET 
patchIU
_patchIU=$
        DS 3*(chmapwidth-1)
        RET 

M7LOOP_PP
;L=v
;H='f(v)
;C=u
;DE=dvdu
;D'='CHMPROG+line#
;HL'=VU
;<100 ⠪⮢  
; 128x128  #C000 (  64x128 + 64x128)
;256 ⠩ 8x8  tiles;#8000 (L= ⠩)
;8 ⠡ t(u), 1 ⠡ f(v)  롮 㦭 t(u)

;室   ⪨ ந室  祭 ࠭ ⪨.
; ।   砥 1 ࠧ  8 
;( ⪨  㬬),   ਬ୮ 1 ࠧ  2 .
;( ᨬ  ⮣, ᪮쪮 ப 祭 ᧠).
_iter=0
       DUP chmapwidth
        LD B,(HL) ;L=v, H='f(v): f(v)=(v/32)+const
        LD A,(BC) ;C=u, B='t()
        EXX 
        LD B,A
       IF _iter==0
         LD C,(HL) ;tile
       else
_a=$
        ORG _patchIV
        LD (_a+3),A
_patchIV=$
        ORG _a
       ;LOCAL 
        JP NC,1f;nincV_PP ;JP C,
        INC H ;V
        BIT 6,H
        JP NZ,1f;nincV_PP
        LD A,L
        XOR 128
        LD L,A
        LD A,H
        OR #C0
        LD H,A
1;nincV_PP
         LD C,(HL) ;tile
       ;ENDL 
       ENDIF 
        ;LD C,(HL) ;tile
        LD A,(BC) ;color
       if toscreen
        ld (de),a
        inc e
       else
        LD E,0xff&{TCHX+256-chmapwidth+_iter}
        LD (DE),A ;chunkmap (LD:PUSH)
       endif
       IF _iter-(chmapwidth-1)
        EXX 
        LD A,C
_a=$
        ORG _patchJU
        LD (_a),A
_patchJU=$
        ORG _a
        ADD A,E
        LD C,A ;u
_a=$
        ORG _patchIU
        LD (_a+4),A
_patchIU=$
        ORG _a
       ;LOCAL 
        JP NC,2f;$+3+3;nincU_PP ;JP C,
        EXX 
        INC L ;U
         LD C,(HL) ;tile
        EXX 
2
;nincU_PP
       ;ENDL 
        LD A,L
_a=$
        ORG _patchJV
        LD (_a),A
_patchJV=$
        ORG _a
        ADD A,D
        LD L,A ;v
       ENDIF 
_iter=_iter+1
       EDUP 
        RET 

        align 256
f_v;=#4800
        ds 256
        display "endcode=",$

        if HIMEM
        ds #8000-$
tiles
        INCBIN "m7zxtile.bin"
        endif

        ;page 3
        org #C000
hicode3begin
        INCBIN "m7zxmap.bin"
hicode3end
progend

	savebin "code.c",progbegin,progend-progbegin
       if 0
        page 3
	savebin "hicode3.c",hicode3begin,hicode3end-hicode3begin
       endif

	LABELSLIST "../us/user.l";,1
